Debian Bug report logs - #634240
FTBFS (arm/unstable): error: unrecognized command line option '-mno-fused-madd'

version graph

Package: squeak-vm; Maintainer for squeak-vm is Debian Squeak Team <pkg-squeak-devel@lists.alioth.debian.org>; Source for squeak-vm is src:squeak-vm.

Reported by: Ricardo Salveti de Araujo <ricardo.salveti@linaro.org>

Date: Mon, 18 Jul 2011 05:21:01 UTC

Severity: serious

Tags: patch

Found in version squeak-vm/1:4.4.7.2357-1

Fixed in version squeak-vm/1:4.4.7.2357-1.1

Done: Neil Williams <codehelp@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian Squeak Team <pkg-squeak-devel@lists.alioth.debian.org>:
Bug#634240; Package squeak-vm. (Mon, 18 Jul 2011 05:21:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ricardo Salveti de Araujo <ricardo.salveti@linaro.org>:
New Bug report received and forwarded. Copy sent to Debian Squeak Team <pkg-squeak-devel@lists.alioth.debian.org>. (Mon, 18 Jul 2011 05:21:04 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Ricardo Salveti de Araujo <ricardo.salveti@linaro.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: FTBFS (arm/unstable): error: unrecognized command line option '-mno-fused-madd'
Date: Mon, 18 Jul 2011 02:19:13 -0300
Package: squeak-vm
Version: 1:4.4.7.2357-1
Severity: important
Tags: sid
Justification: FTBFS on arm

Build log:
....
Linking C static library libFloatArrayPlugin.a
make[3]: Leaving directory `/build/buildd-squeak-vm_4.4.7.2357-1-armel-KoPJRa/squeak-vm-4.4.7.2357/build-tree'
[  9%] Built target FloatArrayPlugin
make[3]: Entering directory `/build/buildd-squeak-vm_4.4.7.2357-1-armel-KoPJRa/squeak-vm-4.4.7.2357/build-tree'
Scanning dependencies of target FloatMathPlugin
make[3]: Leaving directory `/build/buildd-squeak-vm_4.4.7.2357-1-armel-KoPJRa/squeak-vm-4.4.7.2357/build-tree'
make[3]: Entering directory `/build/buildd-squeak-vm_4.4.7.2357-1-armel-KoPJRa/squeak-vm-4.4.7.2357/build-tree'
[ 10%] Building C object FloatMathPlugin/CMakeFiles/FloatMathPlugin.dir/build/buildd-squeak-vm_4.4.7.2357-1-armel-KoPJRa/squeak-vm-4.4.7.2357/unix/src/vm/intplugins/FloatMathPlugin/FloatMathPlugin.c.o
cc1: error: unrecognized command line option '-mno-fused-madd'
make[3]: *** [FloatMathPlugin/CMakeFiles/FloatMathPlugin.dir/build/buildd-squeak-vm_4.4.7.2357-1-armel-KoPJRa/squeak-vm-4.4.7.2357/unix/src/vm/intplugins/FloatMathPlugin/FloatMathPlugin.c.o] Error 1
make[3]: Leaving directory `/build/buildd-squeak-vm_4.4.7.2357-1-armel-KoPJRa/squeak-vm-4.4.7.2357/build-tree'
make[2]: *** [FloatMathPlugin/CMakeFiles/FloatMathPlugin.dir/all] Error 2
make[1]: *** [all] Error 2
make[2]: Leaving directory `/build/buildd-squeak-vm_4.4.7.2357-1-armel-KoPJRa/squeak-vm-4.4.7.2357/build-tree'
make[1]: Leaving directory `/build/buildd-squeak-vm_4.4.7.2357-1-armel-KoPJRa/squeak-vm-4.4.7.2357/build-tree'
make: *** [build-stamp] Error 2
dpkg-buildpackage: error: debian/rules build gave error exit status 2




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Squeak Team <pkg-squeak-devel@lists.alioth.debian.org>:
Bug#634240; Package squeak-vm. (Mon, 18 Jul 2011 06:39:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ricardo Salveti de Araujo <ricardo.salveti@linaro.org>:
Extra info received and forwarded to list. Copy sent to Debian Squeak Team <pkg-squeak-devel@lists.alioth.debian.org>. (Mon, 18 Jul 2011 06:39:04 GMT) Full text and rfc822 format available.

Message #10 received at 634240@bugs.debian.org (full text, mbox):

From: Ricardo Salveti de Araujo <ricardo.salveti@linaro.org>
To: Debian Bug Tracking System <634240@bugs.debian.org>
Subject: debdiff with upstream fix
Date: Mon, 18 Jul 2011 03:35:28 -0300
[Message part 1 (text/plain, inline)]
Package: squeak-vm
Version: 1:4.4.7.2357-1
Severity: normal
Tags: patch

The attached debdiff contains the upstream fix to fix the FTBFS for ARM.

Changelog entry:
  * Added reenable-gcc-optimisations.patch (Closes: #634240, LP: #791243)

Thanks for considering the patch.

-- System Information:
Debian Release: squeeze/sid
[tmp4e6b2A (text/x-diff, attachment)]

Severity set to 'serious' from 'important' Request was from Jakub Wilk <jwilk@debian.org> to control@bugs.debian.org. (Fri, 02 Dec 2011 13:54:09 GMT) Full text and rfc822 format available.

Removed tag(s) sid. Request was from Julien Cristau <julien.cristau@logilab.fr> to control@bugs.debian.org. (Fri, 02 Dec 2011 14:03:03 GMT) Full text and rfc822 format available.

Added tag(s) patch. Request was from Hector Oron <zumbi@debian.org> to control@bugs.debian.org. (Wed, 22 Feb 2012 02:39:03 GMT) Full text and rfc822 format available.

Added tag(s) pending. Request was from Hector Oron <zumbi@debian.org> to control@bugs.debian.org. (Wed, 22 Feb 2012 02:39:03 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Squeak Team <pkg-squeak-devel@lists.alioth.debian.org>:
Bug#634240; Package squeak-vm. (Wed, 22 Feb 2012 02:45:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Hector Oron <zumbi@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Squeak Team <pkg-squeak-devel@lists.alioth.debian.org>. (Wed, 22 Feb 2012 02:45:03 GMT) Full text and rfc822 format available.

Message #23 received at 634240@bugs.debian.org (full text, mbox):

From: Hector Oron <zumbi@debian.org>
To: 634240@bugs.debian.org
Subject: squeak-vm: diff for NMU version 1:4.4.7.2357-1.1
Date: Wed, 22 Feb 2012 03:36:30 +0100
[Message part 1 (text/plain, inline)]
tags 634240 + patch
tags 634240 + pending
thanks

Dear maintainer,

I've prepared an NMU for squeak-vm (versioned as 1:4.4.7.2357-1.1) and
uploaded it to DELAYED/2. Please feel free to tell me if I
should delay it longer.

Regards.

-- 
  Hector Oron
[squeak-vm-4.4.7.2357-1.1-nmu.diff (text/x-diff, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Squeak Team <pkg-squeak-devel@lists.alioth.debian.org>:
Bug#634240; Package squeak-vm. (Wed, 22 Feb 2012 07:03:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to José Luis Redrejo Rodríguez <jredrejo@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Squeak Team <pkg-squeak-devel@lists.alioth.debian.org>. (Wed, 22 Feb 2012 07:03:03 GMT) Full text and rfc822 format available.

Message #28 received at 634240@bugs.debian.org (full text, mbox):

From: José Luis Redrejo Rodríguez <jredrejo@debian.org>
To: Hector Oron <zumbi@debian.org>, 634240@bugs.debian.org
Subject: Re: [Pkg-squeak-devel] Bug#634240: squeak-vm: diff for NMU version 1:4.4.7.2357-1.1
Date: Wed, 22 Feb 2012 07:59:26 +0100
2012/2/22 Hector Oron <zumbi@debian.org>:
> tags 634240 + patch
> tags 634240 + pending
> thanks
>
> Dear maintainer,
>
> I've prepared an NMU for squeak-vm (versioned as 1:4.4.7.2357-1.1) and
> uploaded it to DELAYED/2. Please feel free to tell me if I
> should delay it longer.
>


It's fine for me. Thanks for your help
Regards.

> Regards.
>
> --
>  Hector Oron
>
> _______________________________________________
> Pkg-squeak-devel mailing list
> Pkg-squeak-devel@lists.alioth.debian.org
> http://lists.alioth.debian.org/cgi-bin/mailman/listinfo/pkg-squeak-devel




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Squeak Team <pkg-squeak-devel@lists.alioth.debian.org>:
Bug#634240; Package squeak-vm. (Sat, 03 Mar 2012 20:45:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Neil Williams <codehelp@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Squeak Team <pkg-squeak-devel@lists.alioth.debian.org>. (Sat, 03 Mar 2012 20:45:06 GMT) Full text and rfc822 format available.

Message #33 received at 634240@bugs.debian.org (full text, mbox):

From: Neil Williams <codehelp@debian.org>
To: 634240@bugs.debian.org
Subject: Updated patch to remove embedded libraries
Date: Sat, 3 Mar 2012 20:40:34 +0000
[Message part 1 (text/plain, inline)]
The effect of this updated patch is to use the CMake to link against
the external -lpcre3 and -ljpeg which have also been added to the
Build-Depends. In order to convince the CMake to use the external .c
files, debian/rules gains a command to isolate the relevant .c and .h
files and delete them.

I plan to upload with this revised patch.

-- 


Neil Williams
=============
http://www.linux.codehelp.co.uk/

[634240.diff (text/x-diff, attachment)]
[Message part 3 (application/pgp-signature, inline)]

Reply sent to Neil Williams <codehelp@debian.org>:
You have taken responsibility. (Sat, 03 Mar 2012 21:27:13 GMT) Full text and rfc822 format available.

Notification sent to Ricardo Salveti de Araujo <ricardo.salveti@linaro.org>:
Bug acknowledged by developer. (Sat, 03 Mar 2012 21:27:14 GMT) Full text and rfc822 format available.

Message #38 received at 634240-close@bugs.debian.org (full text, mbox):

From: Neil Williams <codehelp@debian.org>
To: 634240-close@bugs.debian.org
Subject: Bug#634240: fixed in squeak-vm 1:4.4.7.2357-1.1
Date: Sat, 03 Mar 2012 21:24:15 +0000
Source: squeak-vm
Source-Version: 1:4.4.7.2357-1.1

We believe that the bug you reported is fixed in the latest version of
squeak-vm, which is due to be installed in the Debian FTP archive:

squeak-vm_4.4.7.2357-1.1.debian.tar.gz
  to main/s/squeak-vm/squeak-vm_4.4.7.2357-1.1.debian.tar.gz
squeak-vm_4.4.7.2357-1.1.dsc
  to main/s/squeak-vm/squeak-vm_4.4.7.2357-1.1.dsc
squeak-vm_4.4.7.2357-1.1_amd64.deb
  to main/s/squeak-vm/squeak-vm_4.4.7.2357-1.1_amd64.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 634240@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Neil Williams <codehelp@debian.org> (supplier of updated squeak-vm package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Sat, 03 Mar 2012 17:32:01 +0000
Source: squeak-vm
Binary: squeak-vm
Architecture: source amd64
Version: 1:4.4.7.2357-1.1
Distribution: unstable
Urgency: low
Maintainer: Debian Squeak Team <pkg-squeak-devel@lists.alioth.debian.org>
Changed-By: Neil Williams <codehelp@debian.org>
Description: 
 squeak-vm  - The Squeak Smalltalk System (virtual machine)
Closes: 634240
Changes: 
 squeak-vm (1:4.4.7.2357-1.1) unstable; urgency=low
 .
   [ Hector Oron ]
   * Non-maintainer upload.
   * Fix FTBFS (arm): unrecognized command line option '-mno-fused-madd'
     - Thanks Ricardo Salveti de Araujo for patch. (Closes: #634240)
 .
   [ Neil Williams ]
   * Adapt CMake to not build embedded libraries.
Checksums-Sha1: 
 7d0a52949a90ef50cc2d7d33bac13df25a4d5a12 1525 squeak-vm_4.4.7.2357-1.1.dsc
 76ce3820731396a78b56d61ee53d617484895859 84345 squeak-vm_4.4.7.2357-1.1.debian.tar.gz
 681c16fcc70e985151b10f0e99ac2288c6d2fb9b 642562 squeak-vm_4.4.7.2357-1.1_amd64.deb
Checksums-Sha256: 
 f8e9c50be820f36c1d4507c9db8c5368d0aeab9a9e486e19fb07b500d1588c94 1525 squeak-vm_4.4.7.2357-1.1.dsc
 d9769c0fab77ac816b87712f661c045ea001a16c1d96836acdc5d9eeb33fdf16 84345 squeak-vm_4.4.7.2357-1.1.debian.tar.gz
 9b5eb613977d22952f4da1d52e1c0a8e488155f055f8b775bd0adc757331cb2a 642562 squeak-vm_4.4.7.2357-1.1_amd64.deb
Files: 
 1019fa0dd77de6bf22bc87eaf0ba7630 1525 interpreters optional squeak-vm_4.4.7.2357-1.1.dsc
 c724ee33b7e97ffaee7ae0565b76c930 84345 interpreters optional squeak-vm_4.4.7.2357-1.1.debian.tar.gz
 8f7da670bc47aefa119fc386a3339f88 642562 interpreters optional squeak-vm_4.4.7.2357-1.1_amd64.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.12 (GNU/Linux)

iEYEARECAAYFAk9ShccACgkQiAEJSii8s+OXzwCgn/QKXPh6cn3/Ch3KKu33/B14
gWAAn1dZ2yrWbbxAdnrrZ7LHiJM4FaiD
=ccJE
-----END PGP SIGNATURE-----





Information forwarded to debian-bugs-dist@lists.debian.org, Debian Squeak Team <pkg-squeak-devel@lists.alioth.debian.org>:
Bug#634240; Package squeak-vm. (Sun, 04 Mar 2012 15:21:24 GMT) Full text and rfc822 format available.

Acknowledgement sent to Hector Oron <hector.oron@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Squeak Team <pkg-squeak-devel@lists.alioth.debian.org>. (Sun, 04 Mar 2012 15:21:25 GMT) Full text and rfc822 format available.

Message #43 received at 634240@bugs.debian.org (full text, mbox):

From: Hector Oron <hector.oron@gmail.com>
To: Ian Piumarta <piumarta@speakeasy.net>
Cc: Bert Freudenberg <bert@freudenbergs.de>, pierre.boutillier@laposte.net, "David T. Lewis" <lewis@mail.msen.com>, 634240@bugs.debian.org, Neil Williams <codehelp@debian.org>
Subject: Re: [Vm-dev] Re: [Pkg-squeak-devel] squeak-vm_4.4.7.2357-1.1_i386.changes REJECTED
Date: Sun, 4 Mar 2012 16:18:21 +0100
Hello Ian,

[Add CC to original Debian Bug report and Neil Williams for providing
patch for fixing the problem]

2012/3/4 David T. Lewis <lewis@mail.msen.com>:
> On Sat, Mar 03, 2012 at 04:06:06PM -0800, Ian Piumarta wrote:
>> Hi All,
>>
>> The quoted correspondence didn't quite go far enough back to give me details of the original complaint against the embedded library sources, so I could be peeing against entirely the wrong tree, but with that caveat...
>>
>> On Sat, Mar 03, 2012 at 02:19:04PM +0100, Bert Freudenberg wrote:
>> >>
>> >> The embedding of source code for libraries in the Squeak VM sources is historical, probably to spare builders the hassle of hunting down the right sources. On Linux it doesn't really make sense to do that, agreed.
>>
>> Off the top of my head, by using identical plugin sources on all platforms we can:
>>
>> 1. Guarantee access to the plugins for all POSIX-like platforms, including several that were around long before Linux was invented, by including a version of the library that we know has no particular dependencies on any given platform or architecture;
>>
>> 2. Guarantee access to the plugins on platforms that choose not to bundle the required libraries or for which the library maintainer chooses not to spend any time providing compatibility or maintenance (this and the previous are pretty much the above 'historical' that you mention);
>>
>> 3. Guarantee bit-identical results across all platforms;
>>
>> 4. Guarantee no risk of API divergence between a plugin and whatever version of its encapsulated library a given platform chooses to call canonical this week;
>>
>> 5. Guarantee that bugs fixed for the affected plugins/libraries on non-Linux platforms provide benefit to the Linux VM too;
>>
>> 6. Guarantee that bugs fixed for the affected plugins/libraries on the Linux platforms provide benefit to the VMs for all other platforms too;
>>
>> 7. Guarantee adherence to the principle of not fixing something that isn't broken (insofar as our versions rely only on portable standards and a given platform on which we compile adheres properly to those standards);
>>
>> 8. Guarantee that the plugins continue to function when some OS or variant of it decides to replace a bundled library with a newer, bug-ridden, un[der]-tested, 'equivalent' library that most probably comes with a 'better' but completely incompatible API designed with no consideration for backwards compatibility.
>>
>> All of the above are important (and in some cases critical) to someone, somewhere, and the last one has bitten me several times -- and continues to do so to this day.

In Linux distributions, at least Debian, we care about security, if we
have a security bug against libjpeg, that means all the packages
shipping embedded copies have to be patched, and even worse those
packages can have multiple different and modified embedded copies of
the same source. I think you can imagine, security wise, what the
overhead is. Linux distributions, at least Debian, pick just ship one
copy of the library and link software with it, so when a problem
appears, only one patch is needed and the rest of the distribution
benefits from that. If something breaks, then fixing is a must of
course.

>> That said, it would be easy to arrange the CMake files to link a given plugin against a compatible platform-supplied library thereby permitting the given packaging process (for a Linux distribution that objects to the embedded library sources) to remove those parts of Cross that are unwanted.  That's an issue for the maintainer working for the distribution in question and I'd be happy to work with the first of them that determines such a mechanism to be necessary.  The maintainer in question would of course have to understand that by creating a special case for their distribution they would be assuming primary responsibility for solving subsequent compatibility issues (cases 4 and 8) with no guarantee that anyone in the Squeak community would consider the issues high priority or be inclined to help fix them considering their self-inflicted and essentially arbitrary cause.  Of course it is always possible that the current version of a particular library on a particular platform has already become incompatible with our plugins, which would immediate place the package maintainer for the affected platform in the precarious situation mentioned above.
>>
>> A few '--with' options, as were already suggested by Dave I think, are a good first approximation that permits linking against a platform library rather than an embedded one.  Once they are in place it would be very little work to make them the default on a particular distribution leaving the packager free to excise the embedded library sources.
>>
>> Now, what was the problem?  :)

We fixed several problems, and patch is attached at (thanks Neil Williams):
< http://bugs.debian.org/cgi-bin/bugreport.cgi?msg=33;filename=634240.diff;att=1;bug=634240
>

If you could verify the patch and apply the ARM fixes upstream and
make it easier packaging wise to link with system libraries instead
embedded copies, then that would be superb.

In anycase, thanks, for your detailed description.

> Hi Ian,
>
> Yes, I believe that it is a matter of using platform libraries, and
> requiring that copies of platform libraries not be present in the source
> tarball.
>
> My understanding of the issue is that Linux distributions require
> packages to be built from source (your tarball in this case, or some
> modification thereof), and require that this source follow the rules
> with respect to licensing and so forth. Apparently one of the rules
> is that if a library is provided by the Linux distribution itself,
> then the platform provided library should be used, and a local (and
> probably different) version of that library should not be present
> in the Squeak VM tarball.
>
> I am not an expert in Linux distributions, so I'll look to Bert to
> correct me if I have this wrong. But in a nutshell, I think that's
> the issue.
>
> If we could address the build and link issues with cmake as you describe
> above, and then provide some guidance to Linux distribution maintainers
> as to the correct command line options for unix/cmake/configure, I think
> it would be a big help.
>
> I suspect (but do not know for sure) that it may also be helpful to
> provide a separate tarball specifically for Linux distribution builders,
> in addition to the full tarball that you already produce, with problematic
> libary code removed from platforms/Cross. That may help distribution
> maintainers to package the code without worrying about what files or
> libraries need to be excluded.
>
> Thanks a lot for looking into this. My impression is that we have a
> number of people who are willing to work on Linux distribution packaging,
> but who don't necessarily know the details of how to set up the source
> and build process in a repeatable manner. I'm not sure how many
> different Linux distributions might be ultimately be involved, but
> getting this right on Debian certainly seems like a good place to
> start. After all, if it's good enough for Debian, it's going to be
> good enough for everyone :)
>
> Cheers,
> Dave
>



-- 
 Héctor Orón  -.. . -... .. .- -.   -.. . ...- . .-.. --- .--. . .-.




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Mon, 02 Apr 2012 07:38:54 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Wed Apr 16 13:31:06 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.